(*
    ===========================================================================
    C^[lbgڑmFɂ́H
    http://homepage1.nifty.com/MADIA/delphi/delphi_bbs/200312_03120080.html
    ---------------------------------------------------------------------------
    Platform SDK: Remote Access Service MIB_IPADDRROW
    http://msdn.microsoft.com/library/default.asp?url=/library/en-us/rras/rras/mib_ipaddrrow.asp
    ---------------------------------------------------------------------------
    (Borland C++ Builder 5 Professional)/Lib/iphlpapi.h
    ===========================================================================
*)

unit IPHLPAPI;

interface

uses
    Windows;

const
    IPHLPAPI_DLL = 'IPHLPAPI.DLL';

const
    MAX_INTERFACE_NAME_LEN             = $100;
    ERROR_SUCCESS                      = 0;
    MAXLEN_IFDESCR                     = $100;
    MAXLEN_PHYSADDR                    = 8;

    MIB_IF_OPER_STATUS_NON_OPERATIONAL = 0;
    MIB_IF_OPER_STATUS_UNREACHABLE     = 1;
    MIB_IF_OPER_STATUS_DISCONNECTED    = 2;
    MIB_IF_OPER_STATUS_CONNECTING      = 3;
    MIB_IF_OPER_STATUS_CONNECTED       = 4;
    MIB_IF_OPER_STATUS_OPERATIONAL     = 5;

    MIB_IF_TYPE_OTHER                  = 1;
    MIB_IF_TYPE_ETHERNET               = 6;
    MIB_IF_TYPE_TOKENRING              = 9;
    MIB_IF_TYPE_FDDI                   = 15;
    MIB_IF_TYPE_PPP                    = 23;
    MIB_IF_TYPE_LOOPBACK               = 24;
    MIB_IF_TYPE_SLIP                   = 28;

    MIB_IF_ADMIN_STATUS_UP             = 1;
    MIB_IF_ADMIN_STATUS_DOWN           = 2;
    MIB_IF_ADMIN_STATUS_TESTING        = 3;

type
    MIB_IFROW = record
        wszName           : array[0..(MAX_INTERFACE_NAME_LEN * 2-1)] of char;
        dwIndex           : LongInt;
        dwType            : LongInt;
        dwMtu             : LongInt;
        dwSpeed           : LongInt;
        dwPhysAddrLen     : LongInt;
        bPhysAddr         : array[0..(MAXLEN_PHYSADDR - 1)] of Byte;
        dwAdminStatus     : LongInt;
        dwOperStatus      : LongInt;
        dwLastChange      : LongInt;
        dwInOctets        : LongInt;
        dwInUcastPkts     : LongInt;
        dwInNUcastPkts    : LongInt;
        dwInDiscards      : LongInt;
        dwInErrors        : LongInt;
        dwInUnknownProtos : LongInt;
        dwOutOctets       : LongInt;
        dwOutUcastPkts    : LongInt;
        dwOutNUcastPkts   : LongInt;
        dwOutDiscards     : LongInt;
        dwOutErrors       : LongInt;
        dwOutQLen         : LongInt;
        dwDescrLen        : LongInt;
        bDescr            : array[0..(MAXLEN_IFDESCR - 1)] of char;
    end;

    MIB_IFTABLE = record
        dwNumEntries: DWORD;
        table       : array[0..(MAXLEN_PHYSADDR-1)] of MIB_IFROW;
    end;
    PMIB_IFTABLE = ^MIB_IFTABLE;

const
    MIB_IPADDR_PRIMARY      = $0001;    //  Primary IP address
    MIB_IPADDR_DYNAMIC      = $0004;    //  Dynamic IP address
    MIB_IPADDR_DISCONNECTED = $0008;    //  Address is on disconnected interface 
    MIB_IPADDR_DELETED      = $0040;    //  Address is being deleted 
    MIB_IPADDR_TRANSIENT    = $0080;    //  Transient address 

type
    MIB_IPADDRROW = record
        dwAddr      : DWORD;    //  Specifies the IP address
        dwIndex     : DWORD;    //  Specifies the index of the interface
                                //      associated with this IP address
        dwMask      : DWORD;    //  Specifies the subnet mask for the IP address
        dwBCastAddr : DWORD;    //  Specifies the broadcast address. A broadcast
                                //      address is typically the IP address with
                                //      the host portion set to either all zeros
                                //      or all ones
        dwReasmSize : DWORD;    //  Specifies the maximum re-assembly size for
                                //      received datagrams
        unused1     : Word;     //  This member is reserved
        wType       : Word;     //  Specifies the address type or state
    end;

    MIB_IPADDRTABLE = record
        dwNumEntries: DWORD;
        table       : array[0..(MAXLEN_PHYSADDR-1)] of MIB_IPADDRROW;
    end;
    PMIB_IPADDRTABLE = ^MIB_IPADDRTABLE;

function GetIfTable(pIfTable: Pointer; var pdwSize: LongInt;
                    bOrder: LongInt): LongInt;  stdcall;

function GetIpAddrTable(pIpAddrTable: Pointer; var pdwSize: LongInt;
                        bOrder: LongInt): LongInt;  stdcall;

implementation

function GetIfTable; stdcall; external IPHLPAPI_DLL;
function GetIpAddrTable; stdcall; external IPHLPAPI_DLL;

end.
